#pragma once

#include "angles/angles.h"
#include "behaviortree_ros2/bt_action_node.hpp"
#include "tf2/utils.hpp"
#include "tf2_geometry_msgs/tf2_geometry_msgs.hpp"
#include "toid_bt/plugin.hpp"
#include "toid_msgs/action/simple_rotate.hpp"

namespace toid
{

class RotateTowardsNode : public BT::RosActionNode<toid_msgs::action::SimpleRotate>
{
public:
  RotateTowardsNode(
    const std::string & name, const BT::NodeConfig & conf, const BT::RosNodeParams & params,
    PoseFunc pose)
  : BT::RosActionNode<toid_msgs::action::SimpleRotate>(name, conf, params), get_pose(pose)
  {
  }

  static BT::PortsList providedPorts()
  {
    return providedBasicPorts({
      BT::InputPort<double>("x", {}), 
      BT::InputPort<double>("y", {}), 
      BT::InputPort<double>("min_angle", 0, {}),
      BT::InputPort<double>("max_speed", 0, {}),
      //BT::InputPort<double>("options"),
    });
  }

  bool setGoal(Goal & goal) override
  {
    auto x = getInput<double>("x").value();
    auto y = getInput<double>("y").value();
    auto min_angle = getInput<double>("min_angle").value();
    auto max_speed = getInput<double>("max_speed").value();

    geometry_msgs::msg::PoseStamped pose;
    get_pose(pose);

    goal.angle = std::atan2(y - pose.pose.position.y, x - pose.pose.position.x);
    goal.min_angle = angles::from_degrees(min_angle);
    goal.max_speed = max_speed;

    return true;
  }

  void onHalt() override { RCLCPP_INFO(logger(), "%s: onHalt", name().c_str()); }

  BT::NodeStatus onResultReceived(const WrappedResult & wr) override
  {
    return (wr.result->error_code == 0) ? BT::NodeStatus::SUCCESS : BT::NodeStatus::FAILURE;
  }

  BT::NodeStatus onFailure(BT::ActionNodeErrorCode error) override
  {
    RCLCPP_ERROR(logger(), "%s: onFailure with error: %s", name().c_str(), toStr(error));
    return BT::NodeStatus::FAILURE;
  }

  PoseFunc get_pose;
};

}  // namespace toid